## ifupdown-ng 0.11.4~rc1

=== Makefile ===
LAYOUT ?= linux
SCDOC := scdoc
LIBBSD_CFLAGS =
LIBBSD_LIBS =

PACKAGE_NAME := ifupdown-ng
PACKAGE_VERSION := 0.11.3
PACKAGE_BUGREPORT := https://github.com/ifupdown-ng/ifupdown-ng/issues/new


INTERFACES_FILE := /etc/network/interfaces
STATE_FILE := /run/ifstate
CONFIG_FILE := /etc/network/ifupdown-ng.conf
EXECUTOR_PATH := /usr/libexec/ifupdown-ng

CFLAGS ?= -ggdb3 -Os
CFLAGS += -Wall -Wextra
CFLAGS += ${LIBBSD_CFLAGS}
CPPFLAGS = -I.
CPPFLAGS += -DINTERFACES_FILE=\"${INTERFACES_FILE}\"
CPPFLAGS += -DSTATE_FILE=\"${STATE_FILE}\"
CPPFLAGS += -DCONFIG_FILE=\"${CONFIG_FILE}\"
CPPFLAGS += -DPACKAGE_NAME=\"${PACKAGE_NAME}\"
CPPFLAGS += -DPACKAGE_VERSION=\"${PACKAGE_VERSION}\"
CPPFLAGS += -DPACKAGE_BUGREPORT=\"${PACKAGE_BUGREPORT}\"
CPPFLAGS += -DEXECUTOR_PATH=\"${EXECUTOR_PATH}\"


LIBIFUPDOWN_SRC = \
	libifupdown/list.c \
	libifupdown/dict.c \
	libifupdown/interface.c \
	libifupdown/interface-file.c \
	libifupdown/fgetline.c \
	libifupdown/version.c \
	libifupdown/state.c \
	libifupdown/environment.c \
	libifupdown/execute.c \
	libifupdown/lifecycle.c \
	libifupdown/config-parser.c \
	libifupdown/config-file.c \
	libifupdown/compat.c
LIBIFUPDOWN_OBJ = ${LIBIFUPDOWN_SRC:.c=.o}
LIBIFUPDOWN_LIB = libifupdown.a

MULTICALL_SRC = \
	cmd/multicall.c \
	cmd/multicall-options.c \
	cmd/multicall-exec-options.c \
	cmd/multicall-match-options.c \
	cmd/pretty-print-iface.c
MULTICALL_OBJ = ${MULTICALL_SRC:.c=.o}
MULTICALL = ifupdown

# enable ifup/ifdown applets (+16 KB)
CONFIG_IFUPDOWN ?= Y
IFUPDOWN_SRC = cmd/ifupdown.c
MULTICALL_${CONFIG_IFUPDOWN}_OBJ += ${IFUPDOWN_SRC:.c=.o}
CMDS_${CONFIG_IFUPDOWN} += ifup ifdown
CPPFLAGS_${CONFIG_IFUPDOWN} += -DCONFIG_IFUPDOWN

# enable ifquery applet (+4 KB)
# [+20 KB without ifup/ifdown]
CONFIG_IFQUERY ?= Y
IFQUERY_SRC = cmd/ifquery.c
MULTICALL_${CONFIG_IFQUERY}_OBJ += ${IFQUERY_SRC:.c=.o}
CMDS_${CONFIG_IFQUERY} += ifquery
CPPFLAGS_${CONFIG_IFQUERY} += -DCONFIG_IFQUERY

# enable ifctrstat applet (+1 KB)
CONFIG_IFCTRSTAT ?= Y
IFCTRSTAT_SRC = cmd/ifctrstat.c cmd/ifctrstat-${LAYOUT}.c
MULTICALL_${CONFIG_IFCTRSTAT}_OBJ += ${IFCTRSTAT_SRC:.c=.o}
CMDS_${CONFIG_IFCTRSTAT} += ifctrstat
CPPFLAGS_${CONFIG_IFCTRSTAT} += -DCONFIG_IFCTRSTAT

# enable ifparse applet (+1 KB)
CONFIG_IFPARSE ?= Y
IFPARSE_SRC = cmd/ifparse.c
MULTICALL_${CONFIG_IFPARSE}_OBJ += ${IFPARSE_SRC:.c=.o}
CMDS_${CONFIG_IFPARSE} += ifparse
CPPFLAGS_${CONFIG_IFPARSE} += -DCONFIG_IFPARSE

# enable YAML support (+2 KB)
CONFIG_YAML ?= Y
YAML_SRC = \
	libifupdown/yaml-base.c \
	libifupdown/yaml-writer.c
LIBIFUPDOWN_${CONFIG_YAML}_OBJ += ${YAML_SRC:.c=.o}
CPPFLAGS_${CONFIG_YAML} += -DCONFIG_YAML

LIBIFUPDOWN_OBJ += ${LIBIFUPDOWN_Y_OBJ}
MULTICALL_OBJ += ${MULTICALL_Y_OBJ}
CMDS += ${CMDS_Y}
CPPFLAGS += ${CPPFLAGS_Y}

EXECUTOR_SCRIPTS_CORE ?= \
	dhcp \
	ipv6-ra \
	static \
	link \
	ppp \
	forward

EXECUTOR_SCRIPTS_OPT ?= \
	batman \
	bond \
	bridge \
	ethtool \
	gre \
	mpls \
	tunnel \
	vrf \
	vxlan \
	wifi \
	wireguard

EXECUTOR_SCRIPTS ?= ${EXECUTOR_SCRIPTS_CORE} ${EXECUTOR_SCRIPTS_OPT}

EXECUTOR_SCRIPTS_STUB ?=

TARGET_LIBS = ${LIBIFUPDOWN_LIB}
LIBS += ${TARGET_LIBS} ${LIBBSD_LIBS}

all: ${MULTICALL} ${CMDS}

${CMDS}: ${MULTICALL}
	ln -sf ifupdown $@

${MULTICALL}: ${TARGET_LIBS} ${MULTICALL_OBJ}
	${CC} -o $@ ${MULTICALL_OBJ} ${LIBS}

${LIBIFUPDOWN_LIB}: ${LIBIFUPDOWN_OBJ}
	${AR} -rcs $@ ${LIBIFUPDOWN_OBJ}

clean:
	rm -f ${LIBIFUPDOWN_OBJ} ${MULTICALL_OBJ}
	rm -f ${LIBIFUPDOWN_LIB}
	rm -f ${CMDS} ${MULTICALL}
	rm -f ${MANPAGES}

check: ${LIBIFUPDOWN_LIB} ${CMDS}
	kyua test || (kyua report --verbose && exit 1)

install: all
	install -D -m755 ${MULTICALL} ${DESTDIR}/sbin/${MULTICALL}
	for i in ${CMDS}; do \
		ln -s /sbin/${MULTICALL} ${DESTDIR}/sbin/$$i; \
	done
	for i in ${EXECUTOR_SCRIPTS}; do \
		install -D -m755 executor-scripts/${LAYOUT}/$$i ${DESTDIR}${EXECUTOR_PATH}/$$i; \
	done
	for i in ${EXECUTOR_SCRIPTS_STUB}; do \
		install -D -m755 executor-scripts/stub/$$i ${DESTDIR}${EXECUTOR_PATH}/$$i; \
	done
	install -D -m644 dist/ifupdown-ng.conf.example ${DESTDIR}${CONFIG_FILE}.example

.scd.1 .scd.2 .scd.3 .scd.4 .scd.5 .scd.6 .scd.7 .scd.8:
	${SCDOC} < $< > $@

MANPAGES_5 = \
	doc/ifstate.5 \
	doc/ifupdown-ng.conf.5 \
	doc/interfaces.5 \
	doc/interfaces-bond.5 \
	doc/interfaces-batman.5 \
	doc/interfaces-bridge.5 \
	doc/interfaces-forward.5 \
	doc/interfaces-ppp.5 \
	doc/interfaces-tunnel.5 \
	doc/interfaces-vrf.5 \
	doc/interfaces-vxlan.5 \
	doc/interfaces-wifi.5 \
	doc/interfaces-wireguard.5

MANPAGES_7 = \
	doc/ifupdown-executor.7

MANPAGES_8 = \
	doc/ifquery.8 \
	doc/ifup.8 \
	doc/ifdown.8 \
	doc/ifctrstat.8 \
	doc/ifparse.8

MANPAGES = ${MANPAGES_5} ${MANPAGES_7} ${MANPAGES_8}

docs: ${MANPAGES}

install_docs: docs
	for i in ${MANPAGES_5}; do \
		target=$$(basename $$i); \
		install -D -m644 $$i ${DESTDIR}/usr/share/man/man5/$$target; \
	done
	for i in ${MANPAGES_7}; do \
		target=$$(basename $$i); \
		install -D -m644 $$i ${DESTDIR}/usr/share/man/man7/$$target; \
	done
	for i in ${MANPAGES_8}; do \
		target=$$(basename $$i); \
		install -D -m644 $$i ${DESTDIR}/usr/share/man/man8/$$target; \
	done

.SUFFIXES: .scd .1 .2 .3 .4 .5 .6 .7 .8

DIST_NAME = ${PACKAGE_NAME}-${PACKAGE_VERSION}
DIST_TARBALL = ${DIST_NAME}.tar.xz

distcheck: check dist
dist: ${DIST_TARBALL}
${DIST_TARBALL}:
	git archive --format=tar --prefix=${DIST_NAME}/ -o ${DIST_NAME}.tar ${DIST_NAME}
	xz ${DIST_NAME}.tar

=== debian/changelog ===
ifupdown-ng (0.11.4~rc1-1build1) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 17:02:20 +0000

ifupdown-ng (0.11.4~rc1-1) unstable; urgency=medium

  * Initial release. (Closes: #1003796)

 -- Maximilian Wilhelm <max@sdn.clinic>  Sat, 16 Oct 2021 15:40:25 +0200

=== debian/control ===
Source: ifupdown-ng
Section: admin
Priority: optional
Maintainer: Ifupdown NG Maintainers <team+ifupdownng@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Maximilian Wilhelm <max@sdn.clinic>,
 Daniel Gröber <dxld@darkboxed.org>,
Build-Depends:
 atf-sh,
 dh-exec,
 kyua,
 libbsd-dev,
 debhelper-compat (= 12),
 openstack-pkg-tools,
 pkg-config,
 scdoc,
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/ifupdown-ng.git
Vcs-Browser: https://salsa.debian.org/debian/ifupdown-ng
Homepage: https://github.com/ifupdown-ng/ifupdown-ng
Rules-Requires-Root: no

Package: ifupdown-ng
Architecture: any
Conflicts:
 ifupdown,
 ifupdown2,
Provides: ifupdown
Depends:
 adduser,
 freebsd-net-tools [kfreebsd-any],
 inetutils-tools [hurd-any],
 iproute2 [linux-any],
 lsb-base,
 ${misc:Depends},
 ${net:Depends},
 ${shlibs:Depends},
Recommends:
 isc-dhcp-client | dhcp-client,
Suggests:
 ppp,
 rdnssd,
 ${net:Suggests},
Multi-Arch: foreign
Description: Network Interface Management tool similar to ifupdown{,2}
 ifupdown-ng is a network device manager that is largely compatible with
 Debian ifupdown, BusyBox ifupdown and Cumulus Networks' ifupdown2.
 .
 It is intended as a drop-in replacement for all aforementioned suites and
 provides the well-known ifup/ifdown/ifquery tools as well as ifctrstat to
 query interface statistics via CLI.
 .
 ifupdown-ng provides dependecy resolutions between interfaces (physical,
 bond, vlan, bridges, etc.) to configure interfaces in a meaniful order
 independent of their order within the configuration file(s).
 .
 ifupdown-ng currently has support for B.A.T.M.A.N. adv., bonding, bridges,
 MPLS, PPP, regular tunnels + wireguard, VLANs, VRFs, VXLAN, as well as
 setting hardware/driver parameters with ethtool.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/openstack-pkg-tools/pkgos.make

export DESTDIR := "debian/ifupdown-ng/"

%:
	dh $@

override_dh_auto_build:
	# Compatiblity glue for libbsd (strlcpy 'n friends)
	dh_auto_build -- all docs \
		LIBBSD_CFLAGS="-isystem /usr/include/bsd -DLIBBSD_OVERLAY" \
		LIBBSD_LIBS="-isystem /usr/include/bsd -DLIBBSD_OVERLAY -lbsd"

override_dh_auto_install:
	dh_auto_install -- install install_docs

	# Move config file in place and let conffile handling care about updates
	mv debian/ifupdown-ng/etc/network/ifupdown-ng.conf.example debian/ifupdown-ng/etc/network/ifupdown-ng.conf

override_dh_fixperms:
	dh_fixperms
	chmod 755 debian/ifupdown-ng/usr/share/ifupdown-ng/sbin/*

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	HOME=/tmp dh_auto_test
endif

override_dh_installsystemd:
	cp dist/debian/ifupdown-ng.networking.service debian/
	dh_installsystemd --no-scripts --no-restart-after-upgrade --no-stop-on-upgrade --no-start --name networking

## ifupdown-ng 0.12.1

=== Makefile ===
--- 
+++ 
@@ -4,9 +4,10 @@
 LIBBSD_LIBS =
 
 PACKAGE_NAME := ifupdown-ng
-PACKAGE_VERSION := 0.11.3
+PACKAGE_VERSION := 0.12.1
 PACKAGE_BUGREPORT := https://github.com/ifupdown-ng/ifupdown-ng/issues/new
 
+SBINDIR := /sbin
 
 INTERFACES_FILE := /etc/network/interfaces
 STATE_FILE := /run/ifstate
@@ -14,7 +15,8 @@
 EXECUTOR_PATH := /usr/libexec/ifupdown-ng
 
 CFLAGS ?= -ggdb3 -Os
-CFLAGS += -Wall -Wextra
+CFLAGS += -Wall -Wextra -Werror
+CFLAGS += -Wmissing-declarations -Wmissing-prototypes -Wcast-align -Wpointer-arith -Wreturn-type
 CFLAGS += ${LIBBSD_CFLAGS}
 CPPFLAGS = -I.
 CPPFLAGS += -DINTERFACES_FILE=\"${INTERFACES_FILE}\"
@@ -57,7 +59,6 @@
 IFUPDOWN_SRC = cmd/ifupdown.c
 MULTICALL_${CONFIG_IFUPDOWN}_OBJ += ${IFUPDOWN_SRC:.c=.o}
 CMDS_${CONFIG_IFUPDOWN} += ifup ifdown
-CPPFLAGS_${CONFIG_IFUPDOWN} += -DCONFIG_IFUPDOWN
 
 # enable ifquery applet (+4 KB)
 # [+20 KB without ifup/ifdown]
@@ -65,21 +66,18 @@
 IFQUERY_SRC = cmd/ifquery.c
 MULTICALL_${CONFIG_IFQUERY}_OBJ += ${IFQUERY_SRC:.c=.o}
 CMDS_${CONFIG_IFQUERY} += ifquery
-CPPFLAGS_${CONFIG_IFQUERY} += -DCONFIG_IFQUERY
 
 # enable ifctrstat applet (+1 KB)
 CONFIG_IFCTRSTAT ?= Y
 IFCTRSTAT_SRC = cmd/ifctrstat.c cmd/ifctrstat-${LAYOUT}.c
 MULTICALL_${CONFIG_IFCTRSTAT}_OBJ += ${IFCTRSTAT_SRC:.c=.o}
 CMDS_${CONFIG_IFCTRSTAT} += ifctrstat
-CPPFLAGS_${CONFIG_IFCTRSTAT} += -DCONFIG_IFCTRSTAT
 
 # enable ifparse applet (+1 KB)
 CONFIG_IFPARSE ?= Y
 IFPARSE_SRC = cmd/ifparse.c
 MULTICALL_${CONFIG_IFPARSE}_OBJ += ${IFPARSE_SRC:.c=.o}
 CMDS_${CONFIG_IFPARSE} += ifparse
-CPPFLAGS_${CONFIG_IFPARSE} += -DCONFIG_IFPARSE
 
 # enable YAML support (+2 KB)
 CONFIG_YAML ?= Y
@@ -113,11 +111,14 @@
 	vrf \
 	vxlan \
 	wifi \
-	wireguard
+	wireguard \
+	wireguard-quick
 
 EXECUTOR_SCRIPTS ?= ${EXECUTOR_SCRIPTS_CORE} ${EXECUTOR_SCRIPTS_OPT}
 
 EXECUTOR_SCRIPTS_STUB ?=
+
+EXECUTOR_SCRIPTS_NATIVE ?=
 
 TARGET_LIBS = ${LIBIFUPDOWN_LIB}
 LIBS += ${TARGET_LIBS} ${LIBBSD_LIBS}
@@ -143,15 +144,18 @@
 	kyua test || (kyua report --verbose && exit 1)
 
 install: all
-	install -D -m755 ${MULTICALL} ${DESTDIR}/sbin/${MULTICALL}
+	install -D -m755 ${MULTICALL} ${DESTDIR}${SBINDIR}/${MULTICALL}
 	for i in ${CMDS}; do \
-		ln -s /sbin/${MULTICALL} ${DESTDIR}/sbin/$$i; \
+		ln -s ${SBINDIR}/${MULTICALL} ${DESTDIR}${SBINDIR}/$$i; \
 	done
 	for i in ${EXECUTOR_SCRIPTS}; do \
 		install -D -m755 executor-scripts/${LAYOUT}/$$i ${DESTDIR}${EXECUTOR_PATH}/$$i; \
 	done
 	for i in ${EXECUTOR_SCRIPTS_STUB}; do \
 		install -D -m755 executor-scripts/stub/$$i ${DESTDIR}${EXECUTOR_PATH}/$$i; \
+	done
+	for i in ${EXECUTOR_SCRIPTS_NATIVE}; do \
+		install -D -m755 executor-scripts/${LAYOUT}-native/$$i ${DESTDIR}${EXECUTOR_PATH}/$$i; \
 	done
 	install -D -m644 dist/ifupdown-ng.conf.example ${DESTDIR}${CONFIG_FILE}.example
 
@@ -171,7 +175,8 @@
 	doc/interfaces-vrf.5 \
 	doc/interfaces-vxlan.5 \
 	doc/interfaces-wifi.5 \
-	doc/interfaces-wireguard.5
+	doc/interfaces-wireguard.5 \
+	doc/interfaces-wireguard-quick.5
 
 MANPAGES_7 = \
 	doc/ifupdown-executor.7

=== debian/changelog ===
ifupdown-ng (0.12.1-8) unstable; urgency=medium

  * Ensure networking.service is enabled when installing -compat

 -- Daniel Gröber <dxld@darkboxed.org>  Mon, 13 Oct 2025 11:30:31 +0200

ifupdown-ng (0.12.1-7) unstable; urgency=medium

  * Fix Maintainer metadata

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 25 Mar 2025 10:10:35 +0100

ifupdown-ng (0.12.1-6) unstable; urgency=medium

  [ Lee Garrett ]
  * Fix typo in package description

  [ Daniel Gröber ]
  * Simplify command-suffix patch
  * man: Mention pattern support in 'source' statement
  * Implement DEP-17 /usr-move (Closes: #1073735)

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 03 Aug 2024 00:47:43 +0200

ifupdown-ng (0.12.1-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Use the host architecture pkg-config. (Closes: #1070026)

 -- Daniel Gröber <dxld@darkboxed.org>  Mon, 06 May 2024 20:32:54 +0200

ifupdown-ng (0.12.1-4) unstable; urgency=medium

  * Fix FTBFS due to libbsd header location change (Closes: #1066707)
  * Replace B-D pkg-config with pkgconf

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 13 Mar 2024 15:56:58 +0100

ifupdown-ng (0.12.1-3) unstable; urgency=medium

  * Add missing debian/ifupdown-ng.8
  * Fix no-arch-all build

 -- Daniel Gröber <dxld@darkboxed.org>  Fri, 22 Sep 2023 22:30:29 +0200

ifupdown-ng (0.12.1-2) unstable; urgency=medium

  * Drop no longer used ifupdown-ng.manpages.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 20 Sep 2023 22:35:23 +0200

ifupdown-ng (0.12.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Set upstream metadata fields: Repository.

  [ Daniel Gröber ]
  * New upstream release
  * Fix nonsense janitor commits
  * Fix d/watch
  * Add patch to support ifupdown compatible 'source' include patterns
  * Fix bogus ExecRestart systemd unit stanza (Closes: #1006817)
  * Align systemd service dependencies with ifupdown
  * Drop support for kfreebsd/hurd
  * Remove deprecated lsb-base dependency
  * Promote rdnssd to recommends for IPv6-only support by default
  * Fix co-installability with ifupdown
  * Ensure all make targets run under the same environment
  * Fix conflicting files in /usr/share/man
  * Fix networking script perms
  * Add autopkgtest for coinstallability with traditional ifupdown
  * Fix some pedantic lintian complaints
  * Fix upgrade path from stable not installing ifupdown compat

  [ Andrej Shadura ]
  * Add branch configuration to gbp.conf.
  * Update patch metadata.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 20 Sep 2023 15:45:48 +0200

=== debian/control ===
Source: ifupdown-ng
Section: admin
Priority: optional
Maintainer: ifupdown-ng Maintainers <team+ifupdown-ng@tracker.debian.org>
Uploaders:
 Daniel Gröber <dxld@darkboxed.org>,
 Maximilian Wilhelm <max@sdn.clinic>,
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 atf-sh,
 dh-exec,
 kyua,
 libbsd-dev,
 debhelper-compat (= 13),
 pkgconf,
 scdoc,
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/debian/ifupdown-ng.git
Vcs-Browser: https://salsa.debian.org/debian/ifupdown-ng
Homepage: https://github.com/ifupdown-ng/ifupdown-ng
Rules-Requires-Root: no
Description: network interface configuration tool
 ifupdown-ng is a network interface configuration tool that is largely
 compatible with Debian ifupdown, BusyBox ifupdown and Cumulus Networks'
 ifupdown2.
 .
 It is intended as a drop-in replacement for all aforementioned suites and
 provides the well-known ifup/ifdown/ifquery tools as well as ifctrstat to
 query interface statistics via CLI.
 .
 ifupdown-ng provides dependency resolutions between interfaces (physical,
 bond, vlan, bridges, etc.) to configure interfaces in a meaningful order
 independent of their order within the configuration file(s).
 .
 ifupdown-ng currently has support for B.A.T.M.A.N. adv., bonding, bridges,
 MPLS, PPP, regular tunnels + wireguard, VLANs, VRFs, VXLAN, as well as
 setting hardware/driver parameters with ethtool.

Package: ifupdown-ng
Architecture: any
Depends:
 adduser,
 iproute2,
 ${misc:Depends},
 ${net:Depends},
 ${shlibs:Depends},
Recommends:
 ifupdown-ng-compat,
 isc-dhcp-client | dhcp-client,
 rdnssd
Suggests:
 ppp,
 ${net:Suggests},
Multi-Arch: foreign
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: ifupdown-ng-compat
Provides: ifupdown
Conflicts:
 ifupdown,
 ifupdown2,
 ifupdown-ng (<< 0.12.1-1)
Replaces: ifupdown-ng (<< 0.12.1-1)
Architecture: all
Depends: ${misc:Depends}
Description: ${source:Synopsis} -- ifupdown compat
 ${source:Extended-Description}
 .
 This package provides compatibility with traditional ifupdown.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk
SHELL := /bin/bash

%:
	dh $@

ifeq (,$(filter bookworm%,$(DEB_DISTRIBUTION)))
SBINDIR=usr/sbin
else
SBINDIR=sbin
endif

MAKE_VARS := \
		LIBBSD_CFLAGS="$(shell $(PKG_CONFIG) --cflags libbsd-overlay)" \
		LIBBSD_LIBS="$(shell $(PKG_CONFIG) --cflags --libs libbsd-overlay)" \
		SBINDIR=/$(SBINDIR)


override_dh_auto_build:
	# Compatiblity glue for libbsd (strlcpy 'n friends)
	dh_auto_build -- all docs $(MAKE_VARS)

override_dh_auto_install:
	dh_auto_install -- install install_docs $(MAKE_VARS)

	# Move config file in place and let conffile handling care about updates
	mv debian/tmp/etc/network/ifupdown-ng.conf.example debian/tmp/etc/network/ifupdown-ng.conf

	# Everything goes into ifupdown-ng by default except where
	# overridden below
	rm -rf debian/ifupdown-ng
	mv debian/tmp debian/ifupdown-ng

	# Make co-installable with traditional ifupdown and link compat
	# names into ifupdown-ng-compat.
	mkdir -p \
	    debian/ifupdown-ng-compat/$(SBINDIR) \
	    debian/ifupdown-ng-compat/usr/share/man/man8/
	mv debian/ifupdown-ng/$(SBINDIR)/ifupdown debian/ifupdown-ng/$(SBINDIR)/ifupdown-ng
	( cd debian/ifupdown-ng/usr/share/man/; \
	  mv man5/interfaces.5 man5/interfaces-ng.5 \
	)
	for f in if{up,down,query}; do \
	    ln -sf ifupdown-ng debian/ifupdown-ng-compat/$(SBINDIR)/$$f && \
	    rm debian/ifupdown-ng/$(SBINDIR)/$$f && \
	    ln -sf ifupdown-ng debian/ifupdown-ng/$(SBINDIR)/$$f-ng && \
	    mv debian/ifupdown-ng/usr/share/man/man8/$$f.8 debian/ifupdown-ng/usr/share/man/man8/$$f-ng.8 && \
	    ln -sf $$f-ng.8.gz debian/ifupdown-ng-compat/usr/share/man/man8/$$f.8.gz; \
	done
	for f in if{parse,ctrstat}; do \
	    ln -sf ifupdown-ng debian/ifupdown-ng/$(SBINDIR)/$$f; \
	done

execute_after_dh_install:
	install -m 755 -D \
	    -t debian/ifupdown-ng-compat/usr/share/ifupdown-ng/sbin/ \
	    dist/debian/networking
	chmod +x debian/ifupdown-ng-compat/usr/share/ifupdown-ng/sbin/networking

execute_after_dh_compress:
	mkdir debian/ifupdown-ng-compat/usr/share/man/man5
	f=$$(cd debian/ifupdown-ng/usr/share/man/man5/; echo interfaces-ng.5*);\
	gz=$${f#*.5}; \
	ln -sf $$f \
	    debian/ifupdown-ng-compat/usr/share/man/man5/interfaces.5$${gz}

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	HOME=/tmp dh_auto_test
endif

override_dh_installsystemd:
	dh_installsystemd --no-restart-after-upgrade --no-stop-on-upgrade --no-start --name networking

=== debian/tests/control ===
# Make sure ifupdown and ifupdown-ng are coinstallable
Tests: coinstallable
Depends: ifupdown, ifupdown-ng
Restrictions: superficial
